#include <iostream>
#include <vector>

using namespace std;

int N, M;

void nadjiBroj(vector<vector<int>> tabela, int x, int y)
{
    vector<vector<int>> pomocnaTabela(N , vector<int> (M, 0));
    pomocnaTabela[x - 1][y - 1] = -1;
    pomocnaTabela[0][0] = tabela[0][0];

    for(int i = 1; i < N; i++)
        if(pomocnaTabela[i - 1][0] == -1)
            pomocnaTabela[i][0] = -1;
        else if(pomocnaTabela[i][0] != -1)
            pomocnaTabela[i][0] = pomocnaTabela[i - 1][0] + tabela[i][0];

    for(int j = 1; j < M; j++)
        if(pomocnaTabela[0][j - 1] == -1)
            pomocnaTabela[0][j] = -1;
        else if(pomocnaTabela[0][j] != -1)
            pomocnaTabela[0][j] = pomocnaTabela[0][j - 1] + tabela[0][j];


    for(int i = 1; i < N; i++)
    {
        for(int j = 1; j < M; j++)
        {
            if(pomocnaTabela[i][j] != -1)
            {
                if(pomocnaTabela[i - 1][j] == -1)
                    pomocnaTabela[i][j] = pomocnaTabela[i][j - 1] + tabela[i][j];
                else if(pomocnaTabela[i][j - 1] == -1)
                    pomocnaTabela[i][j] = pomocnaTabela[i - 1][j] + tabela[i][j];
                else
                    pomocnaTabela[i][j] = min(pomocnaTabela[i][j - 1], pomocnaTabela[i - 1][j]) + tabela[i][j];
            }
        }
    }

    cout << pomocnaTabela[N - 1][M - 1] << "\n";
}

int main() 
{
    cin >> N >> M;

    vector<vector<int>> glavnaTabela(N , vector<int> (M, 0));

    for(int i = 0; i < N; i++)
        for(int j = 0; j < M; j++)
            cin >> glavnaTabela[i][j];

    int Q;
    cin >> Q;
    int x, y;

    for(int i = 0; i < Q; i++)
    {
        cin >> x >> y;
        nadjiBroj(glavnaTabela, x, y);
    }
}